# -*- coding: utf-8 -*-
'''
Copyright 2012 Rodrigo Pinheiro Matias <rodrigopmatias@gmail.com>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
'''

from hwm.plugin.base import PluginManager, BaseGraphicPlugin
from hwm.helpers import dict_to_namespace
from argparse import ArgumentParser

import signal
import os

def main():
    args = ArgumentParser()
    args.add_argument(
        '--draw',
        dest = 'colector',
        help = u'Specify the colector plugin used for draw data.',
        nargs = '*'
    )
    args.add_argument(
        '--list-graph',
        dest = 'list_graph',
        help = u'Specify the colector plugin used for draw data.',
        action = 'store_true'
    )

    process(args.parse_args())

def process(ns):
    if ns.list_graph is True:
        print 'list-colectores'
    elif ns.colector is not None:
        try:
            kargs = {}
            for arg in ns.colector[1:]:
                kargs.update({arg.split(':')[0]: arg.split(':')[1]})
        except:
            print 'Erro tratando os argumentos, verifique se obdeceu a regra item:valor logo apos o coletor.'
        else:
            pm = PluginManager(BaseGraphicPlugin)
            Colector = pm.get(ns.colector[0])
            c = Colector( dict_to_namespace(**kargs) )
            c.draw()


__name__ == '__main__' and main()